/* GhettoPlay: an S3M browser and playback util
   (c)2000 Dan Potter
*/

#include <kos.h>
#include <jpeg/jpeg.h>
#include "gui.h"

/* Creates the utility texture used for the font and mouse cursor. The
   resulting texture will be 256x256. */
pvr_ptr_t image_texture = NULL;
pvr_poly_hdr_t image_header;

void prep_image(char *file)
{
	pvr_poly_cxt_t tmp;
	if(image_texture == NULL)
	{
		image_texture = (pvr_ptr_t)pvr_mem_malloc(1024*1024*2);
	}
	jpeg_to_texture(file, image_texture, 1024, 1);
	pvr_poly_cxt_txr(&tmp, PVR_LIST_OP_POLY, PVR_TXRFMT_RGB565, 1024, 1024, image_texture, PVR_FILTER_BILINEAR);
	pvr_poly_compile(&image_header, &tmp);
}

void show_image(float alpha, uint32 mode)
{
	pvr_vertex_t vert;
	pvr_prim(&image_header, sizeof(image_header));

	vert.flags = PVR_CMD_VERTEX;
	vert.z = 5.0f;
	vert.argb = PVR_PACK_COLOR(alpha, 1, 1, 1);
	vert.oargb = PVR_PACK_COLOR(alpha, 0, 0, 0);

	// bottom left
	vert.x = 0.0f;
	vert.y = 480.0f;
	vert.u = 0.0f;
	vert.v = 480.0f / 1024.0f;
	pvr_prim(&vert, sizeof(vert));

	// top left 
	vert.x = 0.0f;
	vert.y = 0.0f;
	vert.u = 0.0f;
	vert.v = 0.0f;
	pvr_prim(&vert, sizeof(vert));
		
	// bottom right
	vert.x = 640.0f;
	vert.y = 480.0f;
	vert.u = 640.0f / 1024.0f;
	vert.v = 480.0f / 1024.0f;
	pvr_prim(&vert, sizeof(vert));

	// top right 
	vert.flags = PVR_CMD_VERTEX_EOL;
	vert.x = 640.0f;
	vert.y = 0.0f;
	vert.u = 640.0f / 1024.0f;
	vert.v = 0.0f;
	pvr_prim(&vert, sizeof(vert));
}

