/* Generator is (c) James Ponder, 1997-2001 http://www.squish.net/generator/ */

#include <unistd.h>
#include <string.h>
#include <math.h>

#include "generator.h"
#include "gensound.h"
#include "gensoundp.h"
#include "sndstream.h"
#include "vdp.h"
#include "ui.h"

#include "support.h"
#include "fm.h"

/*** variables externed ***/

/*** forward references ***/

/*** file scoped variables ***/

static int buffered_samples = 0;
unsigned char *audio_buffer = NULL;
unsigned char *audio_temp = NULL;
int sound_playing = 0;

#define AUDIO_BUFFER_SIZE 65537
#define SMOOTH_SIZE 200

void audio_smooth_together(int16 *source_audio, int16 *match_audio)
{
  int16 *dst_left, *dst_right;
  int16 *src_left, *src_right;
  int i; 

  dst_left = source_audio;
  dst_right = source_audio + 1;

  src_left = match_audio;
  src_right = match_audio + 1;

  for(i = 0; i < SMOOTH_SIZE; i++)
  {
    *dst_left = (((*src_left * (SMOOTH_SIZE-i)) / SMOOTH_SIZE) + ((*dst_left * (i)) / SMOOTH_SIZE))/2;
    *dst_right = (((*src_right * (SMOOTH_SIZE-i)) / SMOOTH_SIZE) + ((*dst_right * (i)) / SMOOTH_SIZE))/2;

    dst_left += 2;
    dst_right += 2;
    src_left += 2;
    src_right += 2;
  }
}

void audio_smooth_to_value(int16 *source_audio, int16 match_audio)
{
  int16 *dst_left, *dst_right;
  int i; 

  dst_left = source_audio;
  dst_right = source_audio + 1;
  
  for(i = 0; i < SMOOTH_SIZE; i++)
  {
    *dst_left = (((match_audio * (SMOOTH_SIZE-i)) / SMOOTH_SIZE) + ((*dst_left * (i)) / SMOOTH_SIZE))/2;
    *dst_right = (((match_audio * (SMOOTH_SIZE-i)) / SMOOTH_SIZE) + ((*dst_right * (i)) / SMOOTH_SIZE))/2;

    dst_left += 2;
    dst_right += 2;
  }
}

void *feeder(int size)
{
#ifdef DEBUG_SOUND
  printf("feeder()\n");
  printf("size: %u\n", size);
  printf("buffered_samples: %u\n", buffered_samples);
#endif
  
  if(!sound_playing)
  {
#ifdef DEBUG_SOUND
    printf("returning NULL since sound_playing is 0\n");
#endif
    return NULL;
  }

  if(size > buffered_samples)
  {
/*
    if(size > (buffered_samples * 2)+ SMOOTH_SIZE)
    {
      audio_smooth_to_value((int16 *)audio_temp, audio_temp[buffered_samples]);
    }
    else
    {
      memcpy(audio_temp + (size - buffered_samples), audio_buffer, buffered_samples);
      memcpy(audio_temp, audio_buffer, (size - buffered_samples));
      audio_smooth_together((int16 *)(audio_temp + (size - buffered_samples)), (int16 *)(audio_buffer + (size - buffered_samples)));
      buffered_samples = 0;
    }
*/
    return audio_temp;
  }
  memcpy(audio_temp, audio_buffer, size);
  buffered_samples -= size;
  if(buffered_samples < 0) buffered_samples = 0;
  if(buffered_samples)
  {
    memcpy(audio_buffer, audio_buffer+size, buffered_samples);
  }
  return audio_temp;
}

int sound_thread(void *blah)
{
	while(1) thd_sleep(1);
}
/*** soundp_start - start sound hardware ***/

int soundp_start(void)
{
  buffered_samples = 0;
  sound_playing = 0;
	// For right now the sound is entirely disabled.
	// The sound is to be worked on again in the near future.
  return 0;
  if(audio_buffer == NULL)
  {
    printf("allocating audio_buffer(s)\n");
    audio_buffer = (char *)malloc(AUDIO_BUFFER_SIZE * 2);
    audio_temp = (char *)malloc(AUDIO_BUFFER_SIZE);
    memset(audio_buffer, 0, AUDIO_BUFFER_SIZE * 2);
    memset(audio_temp, 0, AUDIO_BUFFER_SIZE);
    printf("sndstream init\n");
    thd_create(&sound_thread, NULL);
    stream_init(&feeder);
    //stream_poll();
    //return 0;
  }
  printf("sndstream start\n");
  stream_start(sound_speed, 1);
  sound_playing = 1;
  return 0;
}

/*** soundp_stop - stop sound hardware ***/

void soundp_stop(void)
{
	// For right now the sound is entirely disabled.
	// The sound is to be worked on again in the near future.
  return;
  if(sound_playing)
  {
    printf("sndstream stop\n");
    stream_poll();
    sound_playing = 0;
    stream_stop();
  }
}

/*** sound_samplesbuffered - how many samples are currently buffered? ***/

int soundp_samplesbuffered(void)
{
	// Right now this is hacked to return a value that will not force
	// a wait situation for the audio to catch up.  For right now the
	// sound is entirely disabled.  The sound is to be worked on again
	// in the near future.
  return 6;
}

void soundp_output(uint16 *left, uint16 *right, unsigned int samples)
{
  unsigned int i;
	// For right now the sound is entirely disabled.
	// The sound is to be worked on again in the near future.
  return;
  //printf("received %u samples\n", samples);
  /* device is odd and is different to host endianness */
  for (i = 0; i < samples; i++) {
    audio_buffer[buffered_samples + i] = (((left[i] >> 8) & 0x00FF) | ((left[i] << 8) & 0xff00));
    audio_buffer[buffered_samples + i + 1] = (((right[i] >> 8) & 0x00FF) | ((right[i] << 8) & 0xff00));
  }
  buffered_samples += samples;

  stream_poll();
}



