#include "generator.h"
#include "gui.h"
#include "filelist.h"

filelist_t file_entries[4000];
uint16 entry_count = 0;
char pathname[512] = "/cd/";

void make_fake_entries()
{
//    strcpy(file_entries[entry_count].realname, ".");
//    strcpy(file_entries[entry_count].dispname, "./");
//   file_entries[entry_count++].size = -1;

    strcpy(file_entries[entry_count].realname, "..");
    strcpy(file_entries[entry_count].dispname, "../");
    file_entries[entry_count++].size = -1;
}

void build_list()
{
    dirent_t *de;
    uint32 hnd;

    hnd = fs_open(pathname, O_RDONLY | O_DIR);

    if (!hnd) {
	strcpy(pathname, "/cd/");
	hnd = fs_open(pathname, O_RDONLY | O_DIR);
    }

    // Reset number of entries to 0
    entry_count = 0;

    de = fs_readdir(hnd);

    if (de)
    {
	if (strcmp(de->name, "."))
	{
	    make_fake_entries();
	}
    }

    while (de && entry_count < 4000)
    {
	if(de->size != -1)
	{
          char *extension = &de->name[0] + strlen(de->name) - 3;
	  if(stricmp(extension, "smd") && stricmp(extension, "bin"))
	  {
		  de = fs_readdir(hnd);
		  continue;
	  }
	}
	strcpy(file_entries[entry_count].realname, de->name);
	strncpy(file_entries[entry_count].dispname, de->name, 19);
	file_entries[entry_count].dispname[19] = 0;
	file_entries[entry_count].size = de->size;

	// Trim down the display name to something a bit more managable.
	if (de->size == -1)
	{
	    if (strlen(de->name) > 16)
	    {
		file_entries[entry_count].dispname[14] = '.';
		file_entries[entry_count].dispname[15] = '.';
		file_entries[entry_count].dispname[16] = '/';
	    }
	    else
	    {
		file_entries[entry_count].dispname[strlen(de->name)+1] = '\0';
		file_entries[entry_count].dispname[strlen(de->name)] = '/';
	    }
	}
	else if (strlen(de->name) > 16)
	{
	    file_entries[entry_count].dispname[14] = '.';
	    file_entries[entry_count].dispname[15] = '.';
	    file_entries[entry_count].dispname[16] = '.';
	}	
	file_entries[entry_count].dispname[17] = '\0';
	//printf("Adding: %s\n", file_entries[entry_count].dispname);
	entry_count++;

	de = fs_readdir(hnd);
    }
    fs_close(hnd);
    
}
