#include "generator.h"
#include "gui.h"
#include "filelist.h"
#include "dc_utils.h"

uint32 selected;
uint32 displist;
static uint16 rommenu_image[320 * 240];

void draw_listing()
{
	int y = 58;
	int item_count = 0;
	uint32 item = displist;
	static float alpha = 1.0f, dalpha = -0.01f;
	while((item < entry_count) && (item_count < 15))
	{
		draw_poly_strf(32.0f, y, 100.0f, 1.0f, 1.0f, 1.0f, 1.0f, file_entries[item].dispname);
		if(item == selected)
		{
			draw_poly_box(32.0f, y, 252, y+24, 5.2f, alpha, 1.0f, 0.0f, 1.0f, alpha, 1.0f, 0.0f, 1.0f);
		}
		item++;
		y += 24;
		item_count++;
	}
	alpha += dalpha;
	if(alpha <= 0.2f || alpha >= 1.0f)
	{
		dalpha *= -1;
	}
}

void back_one_dir(char *path)
{
	int i;
	i = strlen(path) - 2;
	if(i < 0)
	{
		return;
	}

	while(i >= 0)
	{
		if(path[i] == '/')
		{
			path[i+1] = 0;
			break;
		}
		i--;
	}
	if(strlen(path) < 1)
	{
		strcpy(path, "/");
	}
}

extern int ui_check_cond(uint32 flags);

void gui_runner()
{
	cont_cond_t cond, oldcond;
	unsigned char times = 0;
	unsigned char exit = 0;
	char filename[512];

	load_bmp (rommenu_image, "/cd/images/rommenu.bmp");

	build_list();
	selected = 0;
	displist = 0;
	
	while(!exit)
	{
		pvr_wait_ready();
		pvr_scene_begin();
		
		pvr_list_begin(PVR_LIST_OP_POLY);
		show_image(1.0f, PVR_LIST_OP_POLY);
		pvr_list_finish();
		
		pvr_list_begin(PVR_LIST_TR_POLY);
		draw_listing();
		pvr_list_finish();

		pvr_scene_finish();

		if(cont_get_cond(maple_first_controller(), &cond) < 0)
		{
			exit = 1;
		}
#ifndef RELEASE_BUILD
		else if(!(cond.buttons & CONT_START))
		{
			exit = 1;
		}
#endif
		else if(!(cond.buttons & CONT_DPAD_UP))
		{
			if((oldcond.buttons & CONT_DPAD_UP)||(times == 0))
			{
				if(selected > 0)
				{
					selected--;
				}
				times = 0;
				if(selected == displist)
				{
					displist = selected;
				}
			}
		}
		else if(!(cond.buttons & CONT_DPAD_DOWN))
		{
			if((oldcond.buttons & CONT_DPAD_DOWN)||(times == 0))
			{
				if(selected < entry_count)
				{
					selected++;
				}
				times = 0;
				{
					uint32 item = displist;
					int i = 0;
					while(item < entry_count && item != selected)
					{
						item++;
						i++;
					}
					if(i >= 15)
					{
						displist++;
					}
				}
			}
		}
		else if(!(cond.buttons & CONT_A))
		{
			if(oldcond.buttons & CONT_A)
			{
				if(file_entries[selected].size == -1)
				{
					if(strcmp(file_entries[selected].realname, "."))
					{
						if(!strcmp(file_entries[selected].realname, ".."))
						{
							back_one_dir(pathname);
						}
						else
						{
							if(file_entries[selected].realname[0] != '/')
							{
								strcat(pathname, file_entries[selected].realname);
							}
							else
							{
								strcat(pathname, &file_entries[selected].realname[1]);
							}
							strcat(pathname, "/");
						}
						build_list();
						selected = 0;
						displist = 0;
					}
				}
				else
				{
					uint8 *msg;
					strcpy(filename, pathname);
					strcat(filename, file_entries[selected].realname);
					msg = gen_loadimage(filename);
					if(msg != NULL)
					{
						while(!ui_check_cond(CONT_B))
						{
							pvr_wait_ready();
							pvr_scene_begin();
							pvr_list_begin(PVR_LIST_OP_POLY);
							pvr_dummy_poly(PVR_LIST_OP_POLY);
							pvr_list_finish();
							pvr_list_begin(PVR_LIST_OP_POLY);
							draw_poly_strf(40.0f, 200.0f, 100.0f, 1.0f, 1.0f, 1.0f, 1.0f, "Error loading rom:");
							draw_poly_strf(40.0f, 224.0f, 100.0f, 1.0f, 1.0f, 1.0f, 1.0f, msg);
							draw_poly_strf(40.0f, 400.0f, 100.0f, 1.0f, 1.0f, 1.0f, 1.0f, "PRESS B");
							pvr_list_finish();
							pvr_scene_finish();
						}
					}
					else
					{
						gen_quit = 0;
						ui_loop();
						prep_image("/rd/rommenu.jpg");
					}
				}
			}
		}
		else if(!(cond.buttons & CONT_B))
		{
			if(oldcond.buttons & CONT_B)
			{
				back_one_dir(pathname);
				build_list();
				selected = 0;
				displist = 0;
			}
		}
		else if(!(cond.buttons & CONT_X))
		{
			if(oldcond.buttons & CONT_X)
			{
				options_runner();
				prep_image("/rd/rommenu.jpg");
			}
		}
		else if(cond.ltrig)
		{
			if(!(oldcond.ltrig) || (times == 0))
			{
				int i = 15;
				if(displist > 0)
				{
					selected = displist;
					while(--i && displist > 0)
					{
						displist--;
					}
				}
				times = 0;
			}
		}
		else if(cond.rtrig)
		{
			if(!(oldcond.rtrig) || (times == 0))
			{
				int i = 15;
				if(displist < entry_count - 1)
				{
					while(--i && displist < entry_count - 1)
					{
						displist++;
					}
					selected = displist;
				}
				times = 0;
			}
		}
		else if(!(cond.buttons & CONT_Y))
		{
			if(oldcond.buttons & CONT_Y)
			{
				uint32 hnd = fs_open("/cd/", O_RDONLY | O_DIR);
				fs_ioctl(hnd, NULL, 0);
				fs_close(hnd);

				strcpy(pathname, "/cd/");
				build_list();
				selected = 0;
				displist = 0;
			}
		}

		times++;
		times %= 12;
		oldcond = cond;
	}
}


